{% extends "xdwc/base.jinja" %}

{% block title %}{{ map.name }} - {{ tournament }}{% endblock %}

{% block content %}
    <div class="col-md-12">
        {% include "xdwc/_logo_big.jinja" %}
            <h3 class="float-right mt-4">{% for mapper in map.mapper_players.all() %}
                            {{ html_colors(mapper.nickname)|safe }}
                            {% if not loop.last %} &amp; {% endif %}
                            {% endfor %}</h3>
        <h2 class="page-header">{{ map.name }}</h2>

        <p>{% if prev_map %}<a class="float-left"
                               href="/{{ tournament.slug }}/map/{{ prev_map.xonotic_name }}">&larr; {{ prev_map.name }}</a>{% endif %}
            {% if next_map %}
                <a class="float-right" href="/{{ tournament.slug }}/map/{{ next_map.xonotic_name }}">{{ next_map.name }}
                    &rarr;</a>{% endif %}
        </p>
        <div class="clearfix mb-3"></div>

        <ul class="nav nav-tabs mb-3" id="myTab" role="tablist">
            <li class="nav-item">
                <a class="nav-link active" id="results-tab" data-toggle="tab" href="#results" role="tab"
                   aria-controls="home"
                   aria-selected="true">Results</a>
            </li>
            {% if map.youtube_url %}
                <li class="nav-item">
                    <a class="nav-link" id="video-tab" data-toggle="tab" href="#video" role="tab"
                       aria-controls="video" aria-selected="false">Video</a>
                </li>
            {% endif %}
            <li class="nav-item">
                <a class="nav-link" id="history-tab" data-toggle="tab" href="#history" role="tab"
                   aria-controls="profile" aria-selected="false">History</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" id="distribution-tab" data-toggle="tab" href="#distribution" role="tab"
                   aria-controls="contact" aria-selected="false">Distribution</a>
            </li>
        </ul>
        <div class="tab-content" id="myTabContent">
            <div class="tab-pane fade show active" id="results" role="tabpanel" aria-labelledby="home-tab">
                <div class="row">
                    <div class="col-lg-12 mb-3">
                        <h3>Speed record</h3>
                        <table class="table table-bordered table-striped">
                            <thead>

                            </thead>
                            <tbody>
                            {% for i in speed_records %}
                                <tr>
                                    <td>{{ loop.index }}</td>
                                    <td class="standings-nickname">
                                        <a href="{{ url('xdwc:player', i.player.id) }}">
                                            {{ player_name(i.player) }}
                                        </a>
                                    </td>
                                    <td>{{ i.speed|round }}qu/s</td>
                                    <td style="white-space:nowrap">{{ i.server.name }}</td>
                                </tr>
                            {% endfor %}
                            </tbody>
                        </table>
                    </div>
                    <div class="col-lg-12">
                        <h3>Time Records</h3>
                        <table class="table table-bordered">
                            <thead>

                            </thead>
                            <tbody>
                            {% for i in standings %}
                                <tr">
                                    <td>{{ loop.index }}</td>
                                    <td class="standings-nickname">
                                        <a href="{{ url('xdwc:player', i.time_record.player.id) }}">
                                            {{ player_name(i.time_record.player) }}
                                        </a>
                                    </td>
                                    <td style="white-space:nowrap; background-color: {{ i.time_record.get_background_gradient() }}"
                                        title="{{ i.time_record.timestamp|timesince }}">
                                        {% if i.time_record.youtube_url %}
                                            <a target="_blank"
                                               href="{{ i.youtube_url }}">{{ format_time(i.time_record.time) }}s
                                                <i class="fab fa-youtube"></i></a>
                                        {% else %}
                                            {{ format_time(i.time_record.time) }}s
                                        {% endif %}
                                    </td>
                                    <td style="background-color: {{ i.time_record.get_background_gradient() }}"
                                        title="{{ i.time_record.timestamp|timesince }}">
                                        {{ i.eesystem_points_rounded }}
                                    </td>
                                    <td>
                                        {% if i.time_record.time != best_time %}
                                            +{{ format_time(i.difftime) }}
                                        {% else %}
                                            --
                                        {% endif %}
                                    </td>
                                    <td>{{ i.reltime|round(3) }}</td>
                                    <td style="white-space:nowrap">{{ i.time_record.server.name }}</td>
                                </tr>
                            {% endfor %}
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            {% if map.youtube_url %}
                <div class="tab-pane fade" id="video" role="tabpanel" aria-labelledby="video-tab">
                    <div class="row">
                        <div class="col-lg-12">
                            <h3>Video</h3>
                            {% with video_url = map.youtube_embed_code %}
                                {% include "xdwc/_youtube_embed.jinja" %}
                            {% endwith %}
                        </div>
                    </div>
                </div>
            {% endif %}
            <div class="tab-pane fade" id="history" role="tabpanel" aria-labelledby="profile-tab">
                <div class="row">
                    <div class="col-lg-12">
                        <h3>Grinding History</h3>
                        <div id="plot-history">
                        </div>
                    </div>
                </div>

            </div>
            <div class="tab-pane fade" id="distribution" role="tabpanel" aria-labelledby="contact-tab">

                <div class="row">
                    <div class="col-lg-12">
                        <h3>Record Distribution</h3>
                        <div id="plot-distribution">
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
{% endblock %}

{% block extra_js %}
    <script src="{{ static('js/plotly-latest.min.js') }}"></script>
    <script>
        var historyData = [];
        var trace;
        {% for player, attempts in history.items() %}
            trace = {x: [], y: [], text: [], type: 'scatter', name: '{{ player.nickname_nocolors|truncate(16) }}'};
            {% for timestamp, difftime, time in attempts %}
                trace['x'].push('{{ timestamp }}');
                trace['y'].push('{{ difftime }}');
                trace['text'].push('{{ format_time(time) }}');
            {% endfor %}
            historyData.push(trace);
        {% endfor %}
        var historyLayout = {
            title: 'Grinding History',
            height: 800,
            hovermode: 'closest',
            xaxis: {
                title: 'Date/Time'
            },
            yaxis: {
                title: 'Time (relative to the best)',
                {#range: [{{ bottom_margin }}, 0],#}
                {#autorange: false#}
            }
        };

        var distributionData = [
            {
                x: [{% for i in standings %}{{ i.time_record.time }}, {% endfor %}],
                type: 'histogram',
                autobinx: false,
                opacity: 0.75,
                marker: {
                    color: "rgba(100, 200, 102, 0.7)",
                    line: {
                        color: "rgba(100, 200, 102, 1)",
                        width: 1
                    }
                },

                xbins: {
                    size: 1,
                    start: 0,
                    end: {{ worst_time }}
                }
            }
        ];
        var distributionLayout = {
            title: 'Record Distribution',
            height: 800,
            hovermode: 'closest',
            xaxis: {
                title: 'Time',
                autorange: false,
                range: [{{ best_time }}, {{ best_time * 3 }}]
            },
            yaxis: {
                title: 'Number of records'
                {#range: [{{ bottom_margin }}, 0],#}
                {#autorange: false#}
            }
        };
        var historyPlotRendered = false;
        var distributionPlotRendered = false;
        $('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
            switch (e.target.id) {
                case 'history-tab':
                    if (!historyPlotRendered) {
                        Plotly.newPlot('plot-history', historyData, historyLayout, {responsive: true});
                        historyPlotRendered = true;
                    }
                    break;
                case 'distribution-tab':
                    if (!distributionPlotRendered) {
                        Plotly.newPlot('plot-distribution', distributionData, distributionLayout, {responsive: true});
                        distributionPlotRendered = true;
                    }
            }
        });


    </script>
{% endblock %}
